#include <stdio.h> /* fprintf(3), fputs(3), getc(3), putc(3), stdin, stdout,
                    * EOF */
#include <unistd.h> /* getopt(3) */
#if !defined EX_USAGE || !defined EX_OK
#	include <sysexits.h>
#endif

int main(int argc, char *argv[]){
	int c;
	char showend;
	char showtab;

	showend = 0;
	showtab = 0;

	if(argc > 0)
		while((c = getopt(argc, argv, "et")) != -1)
			switch(c){
			case 'e':	showend = 1; break;
			case 't':	showtab = 1; break;
			default:	goto usage;
			}

	if(argc > optind){
usage:		fprintf(stderr, "Usage: %s (-eht)\n", argv[0]);
		return EX_USAGE;
	}

	while((c = getc(stdin)) != EOF){
		if((c & 0x80) != 0)
			fputs("M-", stdout);
		switch(c ^ 0x80 /* 0b 1000 0000 */){
		case 0x7f:	fputs("^?", stdout);
				break;
		case '\n':	if(showend)
					putc('$', stdout);
		default:
			if(c >= ' ' || c == '\n' || (!showtab && c == '\t'))
				putc(c, stdout);
			else
				fprintf(stdout, "^%c", c + '@');
		}
	}

	return EX_OK;
}
